//+------------------------------------------------------------------+
//|                                                       logger.mq4 |
//|                                   Copyright  2008, Adam Parusel |
//|                                                http://esolvix.de |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Adam Parusel"
#property link      "http://esolvix.de"

extern string  logFile        =  "log.txt";
extern bool    loggingActive  =  false;
extern bool    logToFile      =  false;


/**
 * Set the position of the log file
 *
 * @param file path and file name of our the log file
 */         
void setLogFile(string file)
{
   logFile = file;
}


/**
 * Enables logging to file on diskspace
 *
 */
void enableFileLogging()
{
   logToFile = true;
}


/**
 * Disables logging to file on diskspace
 *
 */
void disableFileLogging()
{
   logToFile = false;
}


/**
 * Enables logging
 *
 */
void enableLogging()
{
   loggingActive = true;
}


/**
 * Disables logging
 *
 */
void disableLogging()
{
   loggingActive = false;
}


/**
 * Prints the log to journal and saves log to file is selected
 *
 */
void printLog(string log)
{
   // Only print or save logs, if loging is activated
   if (loggingActive)
   {
      // If logging to file is selected, save log string to disk
      if (logToFile)
      {
         int handle = FileOpen(logFile, FILE_BIN | FILE_READ | FILE_WRITE, ';');
         if (handle < 1)
         {
            Print ("LOGGING: Error opening file!");
            return(0);
         }
         FileWriteString(handle, log, StringLen(log));
         FileClose(handle);
      }
      
      // Print out log string to journal
      Print(log);
   }
}


